=== 3rdparty/protobuf/CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1.3)
project(protobuf C CXX)

add_definitions(-DGOOGLE_PROTOBUF_CMAKE_BUILD)

if (MSVC)
  # Build with multiple processes
  add_definitions(/MP)
  # MSVC warning suppressions
  add_definitions(
    /wd4018 # 'expression' : signed/unsigned mismatch
    /wd4065 # switch statement contains 'default' but no 'case' labels
    /wd4146 # unary minus operator applied to unsigned type, result still unsigned
    /wd4244 # 'conversion' conversion from 'type1' to 'type2', possible loss of data
    /wd4251 # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
    /wd4267 # 'var' : conversion from 'size_t' to 'type', possible loss of data
    /wd4305 # 'identifier' : truncation from 'type1' to 'type2'
    /wd4307 # 'operator' : integral constant overflow
    /wd4309 # 'conversion' : truncation of constant value
    /wd4334 # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
    /wd4355 # 'this' : used in base member initializer list
    /wd4506 # no definition for inline function 'function'
    /wd4800 # 'type' : forcing value to bool 'true' or 'false' (performance warning)
    /wd4996 # The compiler encountered a deprecated declaration.
  )
  # Allow big object
  add_definitions(/bigobj)

  # Suppress linker warnings about files with no symbols defined.
  set(CMAKE_STATIC_LINKER_FLAGS /ignore:4221)
endif (MSVC)

find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
	add_definitions(-DHAVE_PTHREAD)
endif (CMAKE_USE_PTHREADS_INIT)


include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

#add_definitions(-DUNICODE -D_UNICODE)

file(GLOB LIBPROTOBUF_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/api.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/importer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/parser.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor_database.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/duration.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/dynamic_message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/empty.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set_heavy.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/field_mask.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_reflection.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_table_driven.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/gzip_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/printer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/tokenizer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/map_field.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/reflection_ops.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/service.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/source_context.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/struct.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/mathlimits.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/substitute.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/text_format.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/timestamp.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/type.pb.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/unknown_field_set.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/delimited_message_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_comparator.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_mask_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/datapiece.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/default_value_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/error_listener.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/field_mask_utility.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_escaping.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_stream_parser.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/object_writer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/proto_writer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectsource.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectwriter.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info_test_helper.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/utility.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/json_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/message_differencer.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/time_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/type_resolver_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wrappers.pb.cc
)

file(GLOB LIBPROTOBUF_INCLUDES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/any.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/api.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/importer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/compiler/parser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/descriptor_database.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/duration.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/dynamic_message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/empty.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/field_mask.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_reflection.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/gzip_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/printer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/tokenizer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/map_field.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/reflection_ops.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/service.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/source_context.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/struct.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/mathlimits.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/substitute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/text_format.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/timestamp.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/type.pb.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/unknown_field_set.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/delimited_message_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_comparator.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/field_mask_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/datapiece.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/default_value_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/error_listener.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/field_mask_utility.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_escaping.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/json_stream_parser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/object_writer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/proto_writer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectsource.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/protostream_objectwriter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/type_info_test_helper.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/internal/utility.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/json_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/message_differencer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/time_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/util/type_resolver_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wrappers.pb.h
)

file(GLOB LIBPROTOBUF_LITE_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arena.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arenastring.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_table_driven_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_util.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/implicit_weak_message.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/coded_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message_lite.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/repeated_field.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/bytestream.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/common.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/int128.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/io_win32.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/status.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/statusor.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/stringpiece.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/stringprintf.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/structurally_valid.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/strutil.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/strtod.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/time.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/wire_format_lite.cc
)

file(GLOB LIBPROTOBUF_LITE_INCLUDES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arena.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/arenastring.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/extension_set.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/generated_message_util.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/implicit_weak_message.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/coded_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/strtod.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/io/zero_copy_stream_impl_lite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/message_lite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/repeated_field.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/bytestream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/google/protobuf/stubs/common.h
