=== debian/changelog ===
dde-cooperation (1.1.21) unstable; urgency=medium

  * chore: Update version to 1.1.21.
  * fix: Implement graceful shutdown process in TransferHelper
  * fix: Fix network connect tips
  * fix: Fix not show offline device if not same subnet.
  * fix: Fix not show device for NotAllow mode
  * fix: Fix transfer dialog still show issue

 -- re2zero <yangwu@uniontech.com>  Fri, 10 Oct 2025 13:31:19 +0800

dde-cooperation (1.1.20) unstable; urgency=medium

  * chore: Update version to 1.1.20.
  * fix: Fix some UI issues.
  * fix: Add delay before application exit to ensure config is saved
  * fix: Disable search by self IP

 -- re2zero <yangwu@uniontech.com>  Thu, 18 Sep 2025 19:02:33 +0800

dde-cooperation (1.1.19) unstable; urgency=medium

  * chore: Update version to 1.1.19.
  * fix: Update notification handling to prevent showing in notification center
  * fix: disable logging for sensitive information

 -- re2zero <yangwu@uniontech.com>  Thu, 11 Sep 2025 13:56:43 +0800

dde-cooperation (1.1.18) unstable; urgency=medium

  * chore: Update version to 1.1.18. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Wed, 20 Aug 2025 14:23:54 +0800

dde-cooperation (1.1.17) unstable; urgency=medium

  * chore: Update version to 1.1.16

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 14 Aug 2025 11:30:59 +0800
